﻿using Castle.Windsor;
using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.AspNet.SignalR;

namespace MyWebApplication
{
    public class SignalrHubFactory : DefaultDependencyResolver
    {
        WindsorContainer container;
        public SignalrHubFactory(WindsorContainer container)
        {
            this.container = container;
        }
        public override object GetService(Type serviceType)
        {
            return container.Kernel.HasComponent(serviceType) ? container.Resolve(serviceType) : base.GetService(serviceType);
        }
        public override IEnumerable<object> GetServices(Type serviceType)
        {
            return container.Kernel.HasComponent(serviceType) ? container.ResolveAll(serviceType).Cast<object>() : base.GetServices(serviceType);
        }
    }
}